include dll.e
include msgbox.e


global procedure xmessage(sequence m_title,sequence m_msg)
  if platform()=WIN32 then
    if message_box(m_msg, m_title, MB_OK) then end if
  else
    puts(1, m_title & "\n" & m_msg)
  end if
end procedure
global procedure Message(sequence m_title,sequence m_msg)
  if platform()=WIN32 then
    if message_box(m_msg, m_title, MB_OK) then end if
  else
    puts(1, m_title & "\n" & m_msg)
  end if
end procedure


global function validate_lib(sequence libname)
atom hLib
  hLib = open_dll(libname)
  if hLib<=0 then
    xmessage("Error!","Can\'t load "&libname&".")
    abort(0)
  end if
  return hLib
end function

global function validate_proc(atom lib,sequence name,sequence parms)
integer hProc
  hProc = define_c_proc(lib,name,parms)
  if hProc = -1 then
    xmessage("Error!","Can\'t link " & name & "().")
    abort(0)
  end if
  return hProc
end function


global function validate_func(atom lib,sequence name,sequence parms,atom rtype)
integer hFunc
  hFunc = define_c_func(lib,name,parms,rtype)
  if hFunc = -1 then
    xmessage("Error!","Can\'t link " & name & "().")
    abort(0)
  end if
  return hFunc
end function
