-- Demonstration program for Jarod a/k/a/ the Pretender
-- By Mic, 2000
--
-- This program demonstrates the usage of alpha-blending.
--

include jarod.e

sequence img1,img2,vscreen,bild

integer alpha,d_alpha,d
alpha = 10
d_alpha = 1
d = 1


function init()
  if OPSYS=WIN32 then
    BPP16IS15 = 1
  end if
  if SetColorDepth(16) then
    return 1
  end if

  if GraphicsMode({640,480}) then
    return 1
  end if
  
  img1 = LoadBitmap(PATH("images/model.bmp"))
  img2 = CreateBitmap(256,256,0)

  --// Create a mirrored image.
  Blit({0,0},img1,img2,SOURCECOPY+NOCLIPCOPY+VFLIP+HFLIP) 
  vscreen = CreateBitmap(256,256,0)

  bild = vscreen
  bild[BITCOUNT] = 24
  return 0
end function



function display()
integer key
  UpdateInput()
  key = GetKey()
  if key = KEY_ESCAPE then
    return 1
  elsif key = KEY_S then
    --// Save a snapshot.
    if SaveBitmap("jtest04.bmp",vscreen,bild) then end if
  end if

  SetMixColor(40,110,190,alpha)
  Blit({0,0},img2,vscreen,SOURCECOPY+NOCLIPCOPY)
  Blit({0,0},img1,vscreen,TRANSCOPY)

  WaitRetrace()
  Blit({191,111},vscreen,VIDEO,SOURCECOPY)

  alpha += d_alpha
  if alpha=254 or alpha=1 then
    d_alpha = -d_alpha
  end if
  return 0
end function


function quit()
  DestroyBitmap({img1,img2,vscreen})
  if GraphicsMode(0) then end if
  return 0
end function



WindowType(STANDARD)
WindowTitle("Jarod|jTest04")
Main(routine_id("init"),routine_id("display"),routine_id("quit"))
